# flutter_auth0 plugin

A Flutter plugin to use the [Auth0 API & Auth0 PKCE flow](https://auth0.com/docs/api/authentication).

Note: This plugin is still under development, and some APIs might not be available yet. Feedback and Pull Requests are most welcome!

<div style="display:flex;flex-direction:row;">
    <a href="https://imgur.com/8FXqlC6"><img src="https://i.imgur.com/8FXqlC6.png" title="demo" height="300"/></a>
    <a href="https://imgur.com/4cf1lji"><img src="https://i.imgur.com/4cf1lji.png" title="pkce success" height="300"/></a>
    <a href="https://imgur.com/gQBDeWX"><img src="https://i.imgur.com/gQBDeWX.png" title="api login demo" height="300"/></a>
    <a href="https://imgur.com/hyKGgBX"><img src="https://i.imgur.com/hyKGgBX.png" title="api login demo filled fields" height="300"/></a>
    <a href="https://imgur.com/u4o6Qar"><img src="https://i.imgur.com/u4o6Qar.png" title="api login sucess" height="300"/></a>
</div>

## Example

See the [example application](https://github.com/devdennysegura/flutter-auth0/tree/master/example) source
for a complete sample app using the auth0 authentication.

## What is Auth0?

Auth0 helps you to:

- Add authentication with [multiple authentication sources](https://docs.auth0.com/identityproviders), either social like **Google, Facebook, Microsoft Account, LinkedIn, GitHub, Twitter, Box, Salesforce, amont others**, or enterprise identity systems like **Windows Azure AD, Google Apps, Active Directory, ADFS or any SAML Identity Provider**.
- Add authentication through more traditional **[username/password databases](https://docs.auth0.com/mysql-connection-tutorial)**.
- Add support for **[linking different user accounts](https://docs.auth0.com/link-accounts)** with the same user.
- Support for generating signed [Json Web Tokens](https://docs.auth0.com/jwt) to call your APIs and **flow the user identity** securely.
- Analytics of how, when and where users are logging in.
- Pull data from other sources and add it to the user profile, through [JavaScript rules](https://docs.auth0.com/rules).

## Create a free Auth0 Account

1. Go to [Auth0](https://auth0.com) and click Sign Up.
2. Use Google, GitHub or Microsoft Account to login.

## Author

Denny Segura <dev.dennysegura@gmail.com>

This readme based on [react-native-auth0](https://github.com/auth0/react-native-auth0)

## License

This project is licensed under the MIT license. See the [LICENSE](LICENSE.txt) file for more info.
